#include <math.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "cement.h"

/* Global Variables */
double powLookup[256];

/* Function declarations */
void initilizeLookup(double p);

int main(int argc, char ** argv)
{
    double p=EXPONENT;  /* exponent for pow */
    FILE *fp;
    int i, exp;
    char outfile[20];

    /* Remove the dot from the default exponent. */
    exp = (int)(p * 10);
    if (argc == 2) 
      {
	exp = atoi(argv[1]);
	p = exp / 10.0;
      }

    initilizeLookup(p);

    sprintf(outfile,"powLookup%2d.txt", (int)exp);
    fp=fopen(outfile,"w");
    assert(fp!=NULL);

    fprintf(fp,"%f\n",p);
    
    for(i=0;i<256;i++)
        fprintf(fp,"%12.30f\n",powLookup[i]);

     fclose(fp);
    
    return(0);
}

void initilizeLookup(double p)
{
    int i;

    for(i=0;i<256;i++)
        powLookup[i]=pow((double)i,p);
}

